'
' Demonstrate the buffered USART library that replaces the routines used by the Hrsin command
' The demo will receive bytes from a serial terminal and echo them back
'
' For use with the Proton24 compiler version 1.0.1.0 onwards
'
' The demonstration is setup for a FireWing board
'
    Device = 24HJ128GP502
    Declare Xtal = 32 
'
' USART1 setup
'
    Declare Hserial_Baud = 38400
    Declare Hrsout1_Pin = PORTB.7                   ' Select which pin is to be used for TX with USART1
    Declare Hrsin1_Pin = PORTB.6                    ' Select which pin is to be used for RX with USART1

    Include "USART1_Buffer24.inc"                   ' Load the buffered Hrsin routines into the program
    
    Dim MyByte As Byte
    
'----------------------------------------------------------------------------
Main:  
    PPS_Output(cOut_Pin_RP7, cOut_Fn_U1TX)          ' Set the appropriate PPS pin for the USART1 peripheral TX
    PPS_Input(cIn_Pin_RP6, cIn_Fn_U1RX)             ' Set the appropriate PPS pin for the USART1 peripheral RX

    HRSOut "Type some characters in the serial terminal as fast as possible\r"
       
    While                                           ' Create an infinite loop
        While                                       ' Create an infinite loop
            MyByte = HRSIn, {1000, TimeOutLabel}    ' Receive a serial byte with timeout
            DelayMS 100                             ' Create a large delay between reception and transmission to test the buffer
            HRSOut MyByte                           ' Transmit what was received
        Wend                                        ' Close the loop
'
' Come here if a timeout occurs
TimeOutLabel:  
        HRSOut "\r** Timed Out **\rLooking again for characters\r" 
    Wend                                            ' Look for more serial bytes

